import { ElementAttrs } from "./html";

/* tslint:disable:max-line-length no-empty-interface */

export declare interface SVGElementAttrs extends ElementAttrs {
  xmlbase?: string;
}

export declare interface SVGLangSpaceAttrs {
  xmllang?: string;
  xmlspace?: string;
}

export declare interface SVGCircleElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGClipPathElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGComponentTransferFunctionElementAttrs extends SVGElementAttrs {
}

export declare interface SVGDefsElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGDescElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGEllipseElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGFEBlendElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEColorMatrixElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEComponentTransferElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFECompositeElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEConvolveMatrixElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEDiffuseLightingElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEDisplacementMapElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEDistantLightElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEFloodElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEFuncAElementAttrs extends SVGComponentTransferFunctionElementAttrs {
}

export declare interface SVGFEFuncBElementAttrs extends SVGComponentTransferFunctionElementAttrs {
}

export declare interface SVGFEFuncGElementAttrs extends SVGComponentTransferFunctionElementAttrs {
}

export declare interface SVGFEFuncRElementAttrs extends SVGComponentTransferFunctionElementAttrs {
}

export declare interface SVGFEGaussianBlurElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEImageElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGFEMergeElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEMergeNodeElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEMorphologyElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEOffsetElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFEPointLightElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFESpecularLightingElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFESpotLightElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFETileElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFETurbulenceElementAttrs extends SVGElementAttrs {
}

export declare interface SVGFilterElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGForeignObjectElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGGElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGGradientElementAttrs extends SVGElementAttrs {
}

export declare interface SVGImageElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGLineElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGLinearGradientElementAttrs extends SVGGradientElementAttrs {
}

export declare interface SVGMarkerElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGMaskElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGMetadataElementAttrs extends SVGElementAttrs {
}

export declare interface SVGPathElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGPatternElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGPolygonElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGPolylineElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGRadialGradientElementAttrs extends SVGGradientElementAttrs {
}

export declare interface SVGRectElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGSVGElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGScriptElementAttrs extends SVGElementAttrs {
  type?: string;
}

export declare interface SVGStopElementAttrs extends SVGElementAttrs {
}

export declare interface SVGStyleElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGSwitchElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGSymbolElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGTSpanElementAttrs extends SVGTextPositioningElementAttrs {
}

export declare interface SVGTextContentElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGTextElementAttrs extends SVGTextPositioningElementAttrs {
}

export declare interface SVGTextPathElementAttrs extends SVGTextContentElementAttrs {
}

export declare interface SVGTextPositioningElementAttrs extends SVGTextContentElementAttrs {
}

export declare interface SVGTitleElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}

export declare interface SVGViewElementAttrs extends SVGElementAttrs {
}

export declare interface SVGUseElementAttrs extends SVGElementAttrs, SVGLangSpaceAttrs {
}
